--
-- Loudmouth
-- Author: FatherJim of Blackhand
-- Email:  praetor@slayernet.org
--

--
-- Set up basic ACE2 library and Fubar data structures and methods.
--

local L = AceLibrary("AceLocale-2.2"):new("Loudmouth")
local tablet = AceLibrary("Tablet-2.0")
Loudmouth = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceDebug-2.0", "AceEvent-2.0", "FuBarPlugin-2.0")
Loudmouth:RegisterDB("LoudmouthDB","LoudmouthDBPC")
local crayon = AceLibrary("Crayon-2.0")

Loudmouth.date="01/16/2007"
Loudmouth.version=0.807
Loudmouth.previousbuild="build r25399"

--
-- Set up Keybindings
--

BINDING_HEADER_LM				= L["Loudmouth"]
BINDING_NAME_LM_SHOW_GUI	= L["Display GUI Window"]
BINDING_NAME_LM_EXCUSE_G	= L["Make an Excuse to Guild"]
BINDING_NAME_LM_EXCUSE_O	= L["Make an Excuse to Officer"]
BINDING_NAME_LM_EXCUSE_P	= L["Make an Excuse to Party"]
BINDING_NAME_LM_EXCUSE_R	= L["Make an Excuse to Raid"]
BINDING_NAME_LM_EXCUSE_S	= L["Make an Excuse to Say"]
BINDING_NAME_LM_EXCUSE_Y	= L["Make an Excuse to Yell"]
BINDING_NAME_LM_EXCUSE_1	= L["Make an Excuse to Channel 1"]
BINDING_NAME_LM_EXCUSE_2	= L["Make an Excuse to Channel 2"]
BINDING_NAME_LM_EXCUSE_3	= L["Make an Excuse to Channel 3"]
BINDING_NAME_LM_EXCUSE_4	= L["Make an Excuse to Channel 4"]
BINDING_NAME_LM_EXCUSE_5	= L["Make an Excuse to Channel 5"]
BINDING_NAME_LM_EXCUSE_6	= L["Make an Excuse to Channel 6"]
BINDING_NAME_LM_EXCUSE_7	= L["Make an Excuse to Channel 7"]
BINDING_NAME_LM_EXCUSE_8	= L["Make an Excuse to Channel 8"]
BINDING_NAME_LM_EXCUSE_9	= L["Make an Excuse to Channel 9"]
BINDING_NAME_LM_EXCUSE_10	= L["Make an Excuse to Channel 10"]
--
-- Set up the shared SavedVariables.lua defaults.
--

Loudmouth:RegisterDefaults("char", {
  Version = 0, -- Loudmouth.version
  quotes = {
      ["AFK"] = {
		},
		["Crits"] = {
		},
		["Excuses"] = {
		},
		["Fears"] = {
		},
		["Misses"] = {
			[1] = {
				["emote"] = 1,
				["quote"] = "trips and falls.",
			},
		},
	},
})

Loudmouth:RegisterDefaults("profile", {
  --
  -- Default option values
  --
  Channel = 'Say',
  Debug = 0,
  --
  -- Current State Information
  --
  Version = 0, -- Loudmouth.version
  ActiveSet = "All",
  _QuoteSet = 2,
  _QuoteEvent = 1,
  enabled = {
    ["AFK"] = 1,
    ["Crits"] = 1,
    ["Excuses"] = 1,
	 ["Fears"] = 1,
	 ["Misses"] = 1,
  },
  rates = {
    ["Crits"] = 15,
    ["Fears"] = 33,
    ["Misses"] = 50,
	 ["Wisecrack"] = 15,
  },
  --
  -- Quotes and options
  --
  quotes = {
	 ["Class"] = {
		["DRUID"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["HUNTER"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	   ["MAGE"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	   ["PALADIN"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["PRIEST"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["ROGUE"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["SHAMAN"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
		["WARLOCK"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	 	["WARRIOR"] = {
      	["AFK"] = { }, ["Crits"] = { }, ["Excuses"] = { }, ["Fears"] = { }, ["Misses"] = { },
		},
	 },
    ["Default"] = {
      ["AFK"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "Oops, my ethernet cable fell out, and the bits are making a mess on the carpet... brb",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Got a phone call. I won the Lottery. Back after I buy Blizzard to fix a few things...",
			--},
      },
      ["Crits"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "I just got a critical hit!",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Oops, my weapon just got stuck in you, could you hand that back please?",
			--},
      },
      ["Excuses"] = {
      	--[1] = {
				--["emote"] = 0,
				--["quote"] = "My g/f just called and wife picked up the phone. Sorry, in combat IRL!"
			--},
      },
      ["Fears"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "Hey mob! I didn't say you could leave yet...",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Oh sure, fight me until you think you're gonna lose, then run away like a little girlie...",
			--},
      },
      ["Misses"] = {
        	--[1] = {
				--["emote"] = 0,
				--["quote"] = "Stand still or come closer so I can slap you!",
			--},
			--[2] = {
				--["emote"] = 0,
				--["quote"] = "Oops... I missed.",
			--},
      },
    },
  },
})

--
-- Set up the internal variables, menus and structures that aren't user data
--
local scrollbar = getglobal("LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar")
local statement = nil
local currentquote = {
	["quote"] = "",
	["emote"] = 0,
}
local quotelist = { }

Loudmouth.Channels = { "UI", "Say", "Party", "Raid", "Guild", "Officer" }
Loudmouth.dropdowns={
	Lists={
		["_QuoteEvent"] = { index = "_QuoteEvent", label = "Event Type", selected = 2, table = { [1] = "AFK", [2] = "Crits", [3] = "Excuses", [4] = "Fears", [5] = "Misses" } },
		["_QuoteSet"] = { index = "_QuoteSet", label = "Quote Set", selected = 2, table = {[1] = "All", [2] = "Default", [3] = "Char", [4] = "Class" } },
		["_SendQuote"] = { index = "_SendQuote", label = "", selected = 1, table = { [1] = "Send on Channel", [2] = "Say", [3] = "Yell", [4] = "Party", [5] = "Raid", [6] = "Guild", [7] = "Officer" } },
	},
}
Loudmouth.editing_item=0
Loudmouth.hasIcon = true
--
-- Menu text is defined in the localization file. HTT-topic is the
-- Help Topic Title for 'topic' and HTD-topic is the Help Topic Detail.
-- They will appear in the order shown in the help table.
--
Loudmouth.help={
	[1]= { ["title"]=L["HTT-About"],    ["detail"]=L["HTD-About"] },
	[2]= { ["title"]=L["HTT-Abuse"],    ["detail"]=L["HTD-Abuse"] },
	[3]= { ["title"]=L["HTT-Emote"],    ["detail"]=L["HTD-Emote"] },
	[4]= { ["title"]=L["HTT-Rates"],    ["detail"]=L["HTD-Rates"] },
	[5]= { ["title"]=L["HTT-RefTgt"],   ["detail"]=L["HTD-RefTgt"] },
	[6]= { ["title"]=L["HTT-SpecQSet"], ["detail"]=L["HTD-SpecQSet"] },
	[7]= { ["title"]=L["HTT-NoQAdd"],   ["detail"]=L["HTD-NoQAdd"] },
	[8]= { ["title"]=L["HTT-QMissing"], ["detail"]=L["HTD-QMissing"] },
}
Loudmouth.hideMenuTitle = true
Loudmouth.LastQuoted = 0
Loudmouth.lastQuoteID = {
	 ["AFK"] = 0,
    ["Crits"] = 0,
	 ["Excuses"] = 0,
	 ["Fears"] = 0,
	 ["Misses"] = 0,
  }
Loudmouth.numTabs = 0 -- will be calculated by GUI_Setup_Buttons
Loudmouth.Tabs = {
	[1] = { ["frame"] = "LMFrame_Quote",   ["index"] = 1, 
	["init"] = "", ["text"] = "Quotes", },
	[2] = { ["frame"] = "LMFrame_Options", ["index"] = 2, 
	["init"] = "Loudmouth:GUI_Setup_Options()", ["text"] = "Options", },
	--[3] = { ["frame"] = "LMFrame_Help",    ["index"] = 3, 
	--["init"] = "Loudmouth:GUI_Show_Help()", ["text"] = "Help", },
	[3] = { ["frame"] = "LMFrame_Help",   ["index"] = 3, 
	["init"] = "Loudmouth:GUI_Setup_Help()", ["text"] = "Help", },
}

local options = {
  type = 'group',
  args = {
	header = {
	   type = 'header',
	    name = "Quick Actions",
	    icon = "Interface\\AddOns\\Loudmouth\\icon.tga",
	    iconHeight = 16,
	    iconWidth = 16,
	    order = 1,
	},
	spacer = {
		type = 'header',
		name = 'Config Options',
		order = 10,
	},
	spacer2 = {
		type = 'header',
		name = 'Rate Options',
		order = 17,
	},
	afks = {
		type = 'toggle',
		name = L["AFK Messages"],
		desc = L["Whether AFKs messages will be sent"],
		get = function ()
				return Loudmouth:Get_Event_State("AFK") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("AFK", 1 - Loudmouth:Get_Event_State("AFK"))
	    		Loudmouth:Update_GUI_Data()
		end,
		order = 12,
	},
	crits = {
	    type = 'toggle',
	    name = L["Crit Hits"],
	    desc = L["Will you brag about critical hits?"],
		get = function ()
				return Loudmouth:Get_Event_State("Crits") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Crits", 1 - Loudmouth:Get_Event_State("Crits"))
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 13,
	},
	critrate = {
	    type = 'range',
	    name = L["Crit Rate"],
	    desc = L["How often you brag about critical hits"],
	    min = 0,
	    max = 100,
	    step = 1,
	    isPercent = false,
	    get = function ()
	        	return Loudmouth:Get_Rate("Crits")
	    end,
	    set = function (v)
	         Loudmouth:Set_Rate("Crits",v)
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 18,
	},
	excuses = {
		type = 'toggle',
		name = L["Excuse Messages"],
		desc = L["Whether Excuse messages will be sent"],
		get = function ()
				return Loudmouth:Get_Event_State("Excuses") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Excuses", 1 - Loudmouth:Get_Event_State("Excuses"))
	    		Loudmouth:Update_GUI_Data()
		end,
		order = 14,
	},
	fears = {
	    type = 'toggle',
	    name = L["Fear Effects"],
	    desc = L["Will you comment when mobs run away?"],
		get = function ()
				return Loudmouth:Get_Event_State("Fears") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Fears", 1 - Loudmouth:Get_Event_State("Fears"))
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 15,
	},
	fearrate = {
	    type = 'range',
	    name = L["Fear Rate"],
	    desc = L["How often you taunt about Feared mobs running away"],
	    min = 0,
	    max = 100,
	    step = 1,
	    isPercent = false,
	    get = function ()
	        return Loudmouth:Get_Rate("Fears")
	    end,
	    set = function (v)
	         Loudmouth:Set_Rate("Fears",v)
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 19,
	},
	miss = {
	    type = 'toggle',
	    name = L["Missed Attacks"],
	    desc = L["Will you comment if you miss?"],
		get = function ()
				return Loudmouth:Get_Event_State("Misses") == 1
		end,
		set = function ()
				Loudmouth:Set_Event_State("Misses", 1 - Loudmouth:Get_Event_State("Misses"))
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 16,
	},
	missrate = {
	    type = 'range',
	    name = L["Missed Attack Rate"],
	    desc = L["How often you taunt about Missed Attacks"],
	    min = 0,
	    max = 100,
	    step = 1,
	    isPercent = false,
	    get = function ()
	        	return Loudmouth:Get_Rate("Misses")
	    end,
	    set = function (v)
	         Loudmouth:Set_Rate("Misses",v)
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 20,
	},
	channel = {
	    type = 'text',
	    name = L["Babble Channel"],
	    desc = L["Babble randomly in selected channel"],
	    get = function()
	        	return Loudmouth.db.profile.Channel
	    end,
	    set = function(v)
	        	Loudmouth.db.profile.Channel = v
	    end,
	    validate = Loudmouth.Channels,
		order = 11,
	},
	wisecrack = {
	    type = 'range',
	    name = L["Wisecrack Cooldown"],
	    desc = L["Minimum time between Wisecracks."],
	    min = 5,
	    max = 300,
	    step = 5,
	    isPercent = false,
	    get = function ()
	        	return Loudmouth.db.profile.rates["Wisecrack"]
	    end,
	    set = function (v)
	         Loudmouth.db.profile.rates["Wisecrack"] = v
	    		Loudmouth:Update_GUI_Data()
	    end,
		order = 21,
	},
	afk = {
		type = 'execute',
		name = L["Show AFK Message"],
		desc = L["Show an AFK Message in Guild chat, and raid or party"],
		func = function()
		  		Loudmouth:Output_AFK()
		end,
		order = 2,
	},
	excuse = {
		--type = 'group',
		type = 'text',
		name = L["Show Excuse"],
		desc = L["Show an excuse to Guild and default babble channel"],
		--pass = true,
		usage = "<channel>",
		input = false,
		get = false,
		set = function(x)
				--if (x == "guild") then
					Loudmouth:Output_Excuse(x)
				--end
			  --Loudmouth:Output_Excuse()
		end,
		order = 3,
	   validate = { "-", "UI", "Say", "Yell", "Party", "Raid", "Guild", "Officer", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "g", "o", "p", "r", "s", "y", },
	},
	help = {
		type = 'execute',
		name = L["Show Help"],
		desc = L["Show the Help Pane"],
		func = function()
		  if (not LMFrame:IsShown()) then
		  	LMFrame:Show()
		  end
		  if LMFrame.selectedTab ~= Loudmouth:GUI_Get_Tab_Index("Help") then
		  	LMFrame.selectedTab = Loudmouth:GUI_Get_Tab_Index("Help")
  			PanelTemplates_UpdateTabs(LMFrame)
			Loudmouth:GUI_Tab_OnClick()
		  end
		end,
		order = 5,
	},
	gui = {
		type = 'execute',
		name = L["Show GUI"],
		desc = L["Display GUI Window"],
		func = function()
				Loudmouth:Update_GUI_Data()
		  		Loudmouth:GUI_Show()
		end,
		order = 4,
	},
	hide = {
	   type = 'execute',
	   name = L["Hide GUI"],
	   desc = L["Close GUI Window"],
	   func = function() LMFrame:Hide() end,
		order = 9,
	},
	options = {
		type = 'execute',
		name = L["Show Options"],
		desc = L["Show the Options Pane"],
		func = function()
		  if (not LMFrame:IsShown()) then
		  	LMFrame:Show()
		  end
		  if LMFrame.selectedTab ~= Loudmouth:GUI_Get_Tab_Index("Options") then
		  	LMFrame.selectedTab = Loudmouth:GUI_Get_Tab_Index("Options")
  			PanelTemplates_UpdateTabs(LMFrame)
			Loudmouth:GUI_Tab_OnClick()
		  end
		end,
		order = 6,
	},
	quotes = {
		type = 'execute',
		name = L["Show Quotes"],
		desc = L["Show the Quotes Pane"],
		func = function()
		  if (not LMFrame:IsShown()) then
		  	LMFrame:Show()
		  end
		  if LMFrame.selectedTab ~= Loudmouth:GUI_Get_Tab_Index("Quotes") then
		  	LMFrame.selectedTab = Loudmouth:GUI_Get_Tab_Index("Quotes")
  			PanelTemplates_UpdateTabs(LMFrame)
			Loudmouth:GUI_Tab_OnClick()
		  end
		end,
		order = 7,
	},
	state = {
	   type = 'execute',
	   name = L["Show Status"],
	   desc = L["Show Command Line Status"],
		func = function()
		 		Loudmouth:Output_Command_Line_Status()
		end,
		order = 8,
	},
  },
}

--
-- Set up ACE and Fubar menus
--

Loudmouth:RegisterChatCommand({"/loudmouth","/lm"}, options)
Loudmouth.OnMenuRequest = options

--
-- Ace / Fubar Interface handlers
--

-- If you Left Click on FUBAR icon/text...
function Loudmouth:OnClick()
  Loudmouth:GUI_Show() 
end

--function Loudmouth:OnMenuRequest()
  --self:AddImpliedMenuOptions()
--end

-- Let's build a nice tooltip showing the current state...
function Loudmouth:OnTooltipUpdate()
  local WisecrackCooldown
  local cat = tablet:AddCategory(
    'text', L["Event Type"], 'text2', L["Response Rates"],
	 'columns', 2,
    'child_textR' , 1, 'child_textG' , 1, 'child_textB' , 0,
    'child_textR2', 1, 'child_textG2', 1, 'child_textB2', 0
  )
  if (self:Get_Event_State("AFK") == 1) then
    cat:AddLine( 'text', L["AFK Messages"], 'text2', self:Get_Rate("AFK"))
  end
  if (self:Get_Event_State("Crits") == 1) then
    cat:AddLine( 'text', L["Crit Hits"], 'text2', self:Get_Rate("Crits"))
  end
  if (self:Get_Event_State("Excuses") == 1) then
    cat:AddLine( 'text', L["Excuse Messages"], 'text2', self:Get_Rate("Excuses"))
  end
  if (self:Get_Event_State("Fears") == 1) then
    cat:AddLine( 'text', L["Fear Effects"], 'text2', self:Get_Rate("Fears"))
  end
  if (self:Get_Event_State("Misses") == 1) then
    cat:AddLine( 'text', L["Missed Attacks"], 'text2', self:Get_Rate("Misses"))
  end
  local cat = tablet:AddCategory(
    'text', L["Configuration"], 'columns', 2,
    'child_textR' , 1, 'child_textG' , 1, 'child_textB' , 0,
    'child_textR2', 0, 'child_textG2', 1, 'child_textB2', 1
  )
  cat:AddLine( 'text', L["Babble Channel"], 'text2', self.db.profile.Channel)
  cat:AddLine( 'text', L["Number of Quotes"], 'text2', self.current_total_quotes)
  local activeset
  if (self.current_set_name == "Char" or self.current_set_name == "Class") then
    activeset = self.db.profile.ActiveSet
  else
    activeset = self.current_set_name
  end
  cat:AddLine( 'text', L["Quote Set in Use"], 'text2', activeset)
  if (self:IsDebugging() == true) then
    WisecrackCooldown = L["Disabled"]
  else
    WisecrackCooldown = self.db.profile.rates["Wisecrack"]..L[" seconds"]
  end
  cat:AddLine( 'text', L["Wisecrack Cooldown"], 'text2', WisecrackCooldown)

  --local hours,minutes = GetGameTime();
  --cat:AddLine( 'text', L["Game Time"], 'text2', hours..":"..minutes)
  --cat:AddLine( 'text', L["System Uptime"], 'text2', GetTime())
  tablet:SetTitle(L["Loudmouth"])
  tablet:SetHint(L["Left click to bring up the configuration window. Right click to edit options."])
  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
end

function Loudmouth:Output_Command_Line_Status()
  local eventTypes = ""
  local responseTypes = ""
  local channelName = ""
  local setList = ""
  local set,table

  for k,v in pairs(self.db.profile.enabled) do
    if (v)
	 then	eventTypes = eventTypes.." "..crayon:Colorize("00cf00",k)
	 else	eventTypes = eventTypes.." "..crayon:Colorize("ff0000",k)
	 end
  end
  for k,v in pairs(self.db.profile.rates) do
    --if (self:Get_Event_State(k) == true)
    if (self:Get_Event_State(k)==1)
	 then
    responseTypes = responseTypes.." "..crayon:Colorize("00cf00",k).."="..crayon:Colorize("00cf00",v)
	 else
    responseTypes = responseTypes.." "..crayon:Colorize("ff0000",k).."="..crayon:Colorize("ff0000",v)
	 end
  end
  if (self.db.profile.Channel == "Raid")
  then channelName = crayon:Colorize("ff4f2f","Raid")
  elseif (self.db.profile.Channel == "Party")
  then channelName = crayon:Colorize("7f9fff","Party")
  elseif (self.db.profile.Channel == "Say")
  then channelName = crayon:Colorize("ffffff","Say")
  elseif (self.db.profile.Channel == "UI")
  then channelName = crayon:Colorize("ffffff","UI")
  elseif (self.db.profile.Channel == "Guild")
  then channelName = crayon:Colorize("00ff00","Guild")
  elseif (self.db.profile.Channel == "Officer")
  then channelName = crayon:Colorize("00bf00","Officer")
  end

  for set,table in pairs(self.db.profile.quotes) do
    if (set ~= "Class") then
	 	setList = setList.." "..set
	 end
  end

  self:Print(L["Loudmouth"].." "..self.version.." "..L["status"]..":")
  self:Print("  "..L["Event Type"].."s:"..eventTypes)
  self:Print("  "..L["Response Rates"]..":"..responseTypes)
  self:Print("  "..L["Babble Channel"]..": "..channelName)
  self:Print("  "..L["Number of Quotes"]..": "..crayon:Colorize("9f9fff",self.current_total_quotes))
  self:Print("  "..L["Quote Set in Use"]..": "..crayon:Colorize("00bf00",self.current_set_name))
  self:Print("  "..L["Quote Sets Available"]..":"..crayon:Colorize("9f9fff",setList))
  self:Print("  "..L["Wisecrack Cooldown"]..": "..crayon:Colorize("9f9fff",self.db.profile.rates["Wisecrack"].." "..L["seconds"]))

  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
end

--
-- ACE core functions
--

--function Loudmouth:OnLoad()
  --self:Debug(L["Loudmouth"].." loaded.")
--end

function Loudmouth:OnDisable()
  self:Print("Loudmouth Disabling...");
end

function Loudmouth:OnEnable() -- Called when the addon is enabled
  -- Enable debugging first if active
  self:SetDebugging(self.db.profile.Debug == 1)
  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
  -- Show critical info for troubleshooting
  LMFrame_build:SetText(self.previousbuild)
  LMFrame_Title:SetText(L["Loudmouth"]);
  LMFrame_Version:SetText(L["version"].." "..Loudmouth.version.." "..Loudmouth.date)
  self.current_event_id=self.db.profile["_QuoteEvent"]
  self.current_event_name=self.dropdowns.Lists["_QuoteEvent"].table[self.db.profile["_QuoteEvent"]]
  self.current_set_name=self.dropdowns.Lists["_QuoteSet"].table[self.db.profile["_QuoteSet"]]
  -- Set up the GUI interface first, that way all objects are defined
  LMFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile="Interface/DialogFrame/UI-DialogBox-Border", tileSize=16, edgeSize=16})
  LMFrame:SetBackdropColor(0,0,0,1)
  -- Build GUI
  self:GUI_Setup_Buttons()
  PanelTemplates_SetNumTabs(LMFrame,#self.Tabs)
  LMFrame.selectedTab=1;
  PanelTemplates_UpdateTabs(LMFrame)
  -- Check for upgrade
  if (self.db.profile.Version ~= 0 and self.db.profile.Version ~= Loudmouth.version) then
    self:OnUpgrade()
  	 self.db.profile.Version = Loudmouth.version
  end
  if (self.db.profile.Version == 0) then
    self.db.profile.Version = Loudmouth.version
  end
  -- Clear up the quotes database then populate current state
  Loudmouth:Vasectomy() -- Clean up the quotes db
  _,self.class = UnitClass("Player")
  self:Auto_Vars()
  self.LastQuoted = GetTime()
  self.current_total_quotes = self:Num_Quotes()
  -- Populate our data to the GUI
  self:Update_GUI_Data()
  -- Set some frame LMFrame_Quote cleanup that needs to occur until converted
  -- to dynamic GUI build
  LMFrame_Quote_QuoteList_Highlight_Texture:SetVertexColor(0.70, 0.70, 0.20)
  LMFrame_Quote_QuoteEditLeft:SetTexture()
  LMFrame_Quote_QuoteEditRight:SetTexture()
  LMFrame_Quote_QuoteEditMiddle:SetTexture()
  LMFrame_Quote_QuoteEdit:SetTextInsets(5,5,5,5)
  LMFrame_Quote_QuoteEdit:SetMultiLine(true)
  LMFrame_Quote_QuoteEdit:ClearAllPoints()
  LMFrame_Quote_QuoteEdit:SetPoint("TOPLEFT",LMFrame_Quote,"BOTTOMLEFT",20, 90)
  LMFrame_Quote_QuoteEdit:SetPoint("BOTTOMRIGHT",LMFrame_Quote,"BOTTOMRIGHT",-36, 32)
  LMFrame_Quote_QuoteEdit:SetHeight(58)
  -- Ok, everything should be ready, let's start 'er up and see what happens!
  self:RegisterMyEvents()
end

function Loudmouth:OnUpgrade()
  -- This section called if upgrading from 0.3
  if (self.db.profile.critrate ~= nil) then	
    self.db.profile.rates["Crits"]=self.db.profile.critrate
  	 table.remove(self.db.profile,critrate)
	 self:Print(L["Upgrading from 0.3"]);
  end
  if (self.db.profile.fearrate ~= nil) then	
    self.db.profile.rates["Fears"]=self.db.profile.fearrate
  	 table.remove(self.db.profile,fearrate)
  end
  if (self.db.profile.missrate ~= nil) then	
    self.db.profile.rates["Misses"]=self.db.profile.missrate
  	 table.remove(self.db.profile,missrate)
  end

  -- This section called if upgrading from < 0.6
  if (self.db.profile.crits) then	
    self.db.profile.enabled["Crits"] = self.db.profile.crits
  	 table.remove(self.db.profile,crits)
	 self:Print(L["Upgrading from below 0.6"]);
  end
  if (self.db.profile.fears) then	
    self.db.profile.enabled["Fears"] = self.db.profile.fears
  	 table.remove(self.db.profile,fears)
  end
  if (self.db.profile.miss) then	
    self.db.profile.enabled["Misses"] = self.db.profile.miss
  	 table.remove(self.db.profile,miss)
  end

  -- This section called if upgrading from < 0.8
  if (tonumber(self.db.profile.Version) < 0.8) then
    self:Print(L["Upgrading from below 0.8"])
    local set, event, index, value, value2, value3
    for set,value in pairs(self.db.profile.quotes) do
      self:Debug("Working in Quote Set: "..set)
		if (not self.db.profile.quoteopts) then
		  self.db.profile.quoteopts = {}
		end
		if (not self.db.profile.quoteopts[set]) then	
		  self.db.profile.quoteopts[set] = {}
		end
  	   for event,value2 in pairs(self.db.profile.quotes[set]) do
        self:Debug("Working in Quote Event: "..event)
		  if (not self.db.profile.quoteopts[set][event]) then	
		    self.db.profile.quoteopts[set][event] = {}
		  end
	 	  for index,value3 in pairs(self.db.profile.quotes[set][event]) do
          self:Debug("Working in Quote Index: "..index)
		    if (not self.db.profile.quoteopts[set][event][index]) then	
			   self.db.profile.quoteopts[set][event][index] = {}
		    end
		    if (not self.db.profile.quoteopts[set][event][index]["emote"]) then	
			   self.db.profile.quoteopts[set][event][index]["emote"] = 0
		    end
		  end -- for index
	   end -- for event
    end -- for set
  end -- upgrade to 0.8

  -- This section called if upgrading from < 0.804
  if (tonumber(self.db.profile.Version) < 0.804) then
    self:Print(L["Upgrading from below 0.804"])
	 local set, event, index, index2, thisquote, value, value2, value3
	 for set, value in pairs(self.db.profile.quotes) do
	   self:Debug("Working in Quote Set: "..set)
		for event, value2 in pairs(self.db.profile.quotes[set]) do
        self:Debug("Working in Quote Event: "..event)
		  index2 = 1
		  for index, value3 in pairs(self.db.profile.quotes[set][event]) do
          self:Debug("Working in Quote: "..index)
			 if (self.db.profile.quotes[set][event][index] ~= nil) then
			   if (not self.db.profile.quotes[set][event][index]["quote"]) then
		        thisquote = self.db.profile.quotes[set][event][index]
			     self.db.profile.quotes[set][event][index2] = {}
			     self.db.profile.quotes[set][event][index2]["quote"] = thisquote
			   end
			   if (not self.db.profile.quoteopts or not self.db.profile.quoteopts[set] or not self.db.profile.quoteopts[set][event] or not self.db.profile.quoteopts[set][event][index]) then
			     self.db.profile.quotes[set][event][index2]["emote"] = 0
			   else
			     self.db.profile.quotes[set][event][index2]["emote"] = self.db.profile.quoteopts[set][event][index]["emote"]
			   end
				index2 = index2 + 1
			 end -- index is nil
		  end -- for index
		  for index = index2, #self.db.profile.quotes[set][event] do
		    table.remove(self.db.profile.quotes[set][event],index)
		  end -- for index
		end -- for event
	 end -- for set
	 table.remove(self.db.profile,quoteopts)
  end -- upgrade to 0.804

  -- This section called if upgrading from < 0.804
  if (tonumber(self.db.profile.Version) < 0.804) then
    self:Print(L["Upgrading from below 0.804"])
	 if (self.db.profile.enabled["AFK"] == false) then
      self.db.profile.enabled["AFK"] = 0
	 end
	 if (self.db.profile.enabled["AFK"] == true) then
      self.db.profile.enabled["AFK"] = 1
	 end
	 if (self.db.profile.enabled["Crits"] == false) then
      self.db.profile.enabled["Crits"] = 0
	 end
	 if (self.db.profile.enabled["Crits"] == true) then
      self.db.profile.enabled["Crits"] = 1
	 end
	 if (self.db.profile.enabled["Excuses"] == false) then
      self.db.profile.enabled["Excuses"] = 0
	 end
	 if (self.db.profile.enabled["Excuses"] == true) then
      self.db.profile.enabled["Excuses"] = 1
	 end
	 if (self.db.profile.enabled["Fears"] == false) then
      self.db.profile.enabled["Fears"] = 0
	 end
	 if (self.db.profile.enabled["Fears"] == true) then
      self.db.profile.enabled["Fears"] = 1
	 end
	 if (self.db.profile.enabled["Misses"] == false) then
      self.db.profile.enabled["Misses"] = 0
	 end
	 if (self.db.profile.enabled["Misses"] == true) then
      self.db.profile.enabled["Misses"] = 1
	 end
  end -- upgrade to 0.806

  self:Print(L["Upgrading data structures from version "]..self.db.profile.Version..L[" to "]..Loudmouth.version)
end

--
-- Loudmouth UI construction code
--

function Loudmouth:GUI_Build_ListBox(listName,length,width,dataTable,updateFrame)
  local i
  local scroller = getglobal(listName)

  for i=1, length do
    button=CreateFrame("Button",listName.."_Button"..i,scroller)
	 button:SetWidth(width)
	 button:SetHeight(16)
	 if (i > 1) then
	   button:SetPoint("TOPLEFT",getglobal(listName.."_Button"..i-1),"BOTTOMLEFT")
	 else
	   button:SetPoint("TOPLEFT",scroller,"TOPLEFT",5,-5)
	 end
	 button:SetScript("OnLoad",function() button:SetFrameLevel(scroller:GetFrameLevel()+1) end)
	 button:SetScript("OnClick",function() 
	   getglobal(updateFrame.."_Title"):SetText(string.gsub(Loudmouth.help[i]["title"],"    ",""))
	   getglobal(updateFrame.."_Text"):SetText(Loudmouth.help[i]["detail"])
		--getglobal(this:GetName().."_Text"):SetTextColor(1,1,1)
	 end)
	 label = button:CreateFontString(button:GetName().."_Text","OVERLAY","GameFontNormalSmall")
	 label:SetAllPoints(button)
	 label:SetWidth(width)
	 label:SetHeight(16)
	 label:SetJustifyH("LEFT")
	 --label:SetText("Button #"..i.." default text")
	 if (dataTable[i]) then
	 	label:SetText(dataTable[i]["title"])
	 end
	 label:SetTextColor(0.8, 0.8, 0.3)
  end
end

function Loudmouth:GUI_Setup_Buttons()
  local button, i, prevtabname, tabname

  for i = 1, #self.Tabs do
    tabname = "LMFrameTab"..i
	 prevtabname = "LMFrameTab"..(i-1)
	 button = CreateFrame("Button",tabname,LMFrame,"LM_Tab_Template")
    self.Tabs[i]["tablink"] = button
	 if (i > 1) then
    	button:SetPoint("RIGHT",prevtabname,"LEFT",10,0)
	 else
    	button:SetPoint("BOTTOMRIGHT",-7,-30)
	 end
    button:SetText(self.Tabs[i]["text"])
    button:SetID(i)
	 --if (i > 3) then
	 if (not getglobal(self.Tabs[i]["frame"])) then
	   button = CreateFrame("Frame",self.Tabs[i]["frame"],LMFrame)
      self.Tabs[i]["framelink"] = button
	 end
	 if (strlen(self.Tabs[i]["init"]) > 3) then
	 	assert(loadstring(self.Tabs[i]["init"])) ()
	 end
  end
  self.Tabs[1]["framelink"] = getglobal("LMFrame_Quote")
  --self.Tabs[2]["framelink"] = getglobal("LMFrame_Options")
  --self.Tabs[3]["framelink"] = getglobal("LMFrame_Help")
end

function Loudmouth:GUI_Setup_Help()
  local tabname = self:GUI_Get_Tab_Index("Help")
  local frame = self.Tabs[tabname]["framelink"]
  local basePath = self.Tabs[tabname]["frame"]
  local button, childFrame, i, label, scroller, texture

  label = frame:CreateFontString(basePath.."_Label","OVERLAY","GameFontNormalLarge")
  frame:Hide()
  frame:SetAllPoints(LMFrame)
  label:SetText("Loudmouth "..self.Tabs[tabname]["text"])
  label:SetPoint("TOP",frame, "TOP", 0, -40)

  scroller=CreateFrame("Frame",(basePath.."_TopicList"),frame)
  scroller:SetWidth(200)
  scroller:SetHeight(330)
  scroller:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tileSize=16, edgeSize=16})
  scroller:SetPoint("TOPLEFT",frame,"TOPLEFT",20,-70)
  label = scroller:CreateFontString(basePath.."_Label","OVERLAY","GameFontNormalSmall")
  label:SetText("Help Topics")
  label:SetPoint("TOP",scroller,"TOP",0,12)
  
  self:GUI_Build_ListBox(scroller:GetName(),20,190,self.help,basePath.."_TopicText_ScrollChild")

  scroller=CreateFrame("ScrollFrame",basePath.."_TopicText",frame,UIPanelScrollFrameTemplate)
  scroller:SetWidth(340)
  scroller:SetHeight(330)
  scroller:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tileSize=16, edgeSize=16})
  scroller:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-20,-70)
  label = scroller:CreateFontString(basePath.."_Label","OVERLAY","GameFontNormalSmall")
  label:SetText("Topic Text")
  label:SetPoint("TOP",scroller,"TOP",0,12)

  childFrame=CreateFrame("Frame",basePath.."_TopicText_ScrollChild",scroller)
  scroller:SetScrollChild(childFrame)
  childFrame:SetWidth(300)
  childFrame:SetHeight(325)
  childFrame:SetBackdrop({bgFile = "Interface/Stationery/AuctionStationery1", tileSize=16, edgeSize=16})
  --childFrame:SetBackdrop({bgFile = "Interface/AddOns/Loudmouth/Stationery", tileSize=16, edgeSize=16})
  childFrame:SetAllPoints(scroller)
  label = childFrame:CreateFontString(basePath.."_TopicText_ScrollChild_Title","OVERLAY","QuestTitleFont")
  label:SetPoint("TOPLEFT",childFrame,"TOPLEFT",35,-20)
  label:SetText(self.help[1]["title"])

  label = childFrame:CreateFontString(basePath.."_TopicText_ScrollChild_Text", "OVERLAY", "QuestFont")
  label:SetPoint("TOPLEFT", getglobal("LMFrame_Help_TopicText_ScrollChild_Title"), "BOTTOMLEFT", 0, 0)
  label:SetJustifyH("LEFT")
  label:SetWidth(300)
  label:SetText(self.help[1]["detail"])
  scroller:UpdateScrollChildRect()
  scroller:EnableMouseWheel()
  --getglobal(scroller:GetName().."ScrollBar"):SetValue(0)
end

function Loudmouth:GUI_Setup_Options()
  local tabname = self:GUI_Get_Tab_Index("Options")
  local frame = self.Tabs[tabname]["framelink"]
  local basePath = self.Tabs[tabname]["frame"]
  local checkbox, label, slider

  frame:Hide()
  frame:SetAllPoints(LMFrame)

  checkbox = CreateFrame("CheckButton", basePath.."_Debug",frame,"OptionsCheckButtonTemplate")
  checkbox:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-20,20)
  checkbox:SetScript("OnClick", function()
    self:GUI_Check_Click(this)
	 self:Update_GUI_Data()
  end)
  label = frame:CreateFontString(checkbox:GetName().."_Label", "OVERLAY", "GameFontNormalSmall")
  label:SetPoint("RIGHT", checkbox, "LEFT", 0, 0)
  label:SetJustifyH("RIGHT")
  label:SetText("Debugging")

  slider = CreateFrame("Slider",basePath.."_Wisecrack",frame,"LM_Rate_Template")
  slider:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-20,-70)
  getglobal(slider:GetName().."_Label"):SetText("Wisecrack Cooldown")
  getglobal(slider:GetName().."_Label"):ClearAllPoints()
  getglobal(slider:GetName().."_Label"):SetPoint("BOTTOM",slider:GetName(),"TOP",-20,0)
  getglobal(slider:GetName().."_Slider"):SetValueStep(5)
  getglobal(slider:GetName().."_Slider"):SetMinMaxValues(5,300)
  getglobal(slider:GetName().."_Slider"):SetValue(self:Get_Rate("Wisecrack"))
  getglobal(slider:GetName().."_SliderLow"):SetText("5")
  getglobal(slider:GetName().."_SliderHigh"):SetText("300")

--Loudmouth.Channels = { "UI", "Say", "Party", "Raid", "Guild", "Officer" }
end

--
-- Loudmouth UI handlers
--

function Loudmouth:GUI_Check_Click(box)
  if (box:GetName() == "LMEditFrame_Emote") then	
	 if (self.editing_item ~= 0) then
      self.db.profile.quotes[self.current_set_name][self.current_event_name][self.editing_item]["emote"]=box:GetChecked()
	 end
  end
  if (box:GetName() == "LMFrame_Quote_Enable") then
    self:Set_Event_State(self.current_event_name,box:GetChecked())
  end
  if (box:GetName() == "LMFrame_Options_Debug") then
    if (box:GetChecked() == 1) then
      self.db.profile.Debug = 1
	 else
      self.db.profile.Debug = 0
	 end
    self:SetDebugging(self.db.profile.Debug == 1)
	 self:Print("Debug: now "..self.db.profile.Debug)
  end
  self:Update_GUI_Data()
end

function Loudmouth:GUI_DropDown_Initialize()
  local info, index, value, key;
  for index, value in pairs(Loudmouth.dropdowns.Lists) do
  	if (this:GetName() == "LMFrame_Quote"..value.index.."Button" or
  	    this:GetName() == "LMFrame_Quote"..value.index)
	then
		local label = getglobal("LMFrame_Quote"..index.."_Label")
		if (strlen(value.label) >= 2) then
			label:SetText(value.label)
		end
		for key = 1, #value.table do
			info = UIDropDownMenu_CreateInfo()
			if (self.db.profile)
			then
				if (key == self.db.profile[index])
				then	info.checked = true
				else	info.checked = nil
				end
			end
			info.text = value.table[key]
			info.func = function(x) self:GUI_DropDown_OnClick(x) end
			info.arg1 = value.index
			UIDropDownMenu_AddButton(info)
		end
		if (string.find(this:GetName(),"_SendQuote"))
		then	local name,number
				for k = 1, 10  do
				   number,name = GetChannelName(k)
					if (name ~= nil) then
						info = UIDropDownMenu_CreateInfo()
						info.text = name
						info.value = k
						info.func = function(x) self:GUI_DropDown_OnClick(x) end
						info.arg1 = value.index
						UIDropDownMenu_AddButton(info)
					end
				end
		end
		break;
	end
	UIDropDownMenu_SetSelectedID(this, this:GetID())
  end
end

function Loudmouth:GUI_DropDown_OnClick(list)
  local ddl = getglobal("LMFrame_Quote"..list)
  UIDropDownMenu_SetSelectedID(ddl, this:GetID())
  local selected = UIDropDownMenu_GetSelectedValue("LMFrame_Quote"..list)

  if (list == "_SendQuote")
  then	local channel = this:GetText()
  			if (this:GetID() ~= 1)
			then
				if (this:GetID() > #self.dropdowns.Lists["_SendQuote"].table)
				then
					SendChatMessage(LMFrame_Quote_QuoteEdit:GetText(),"CHANNEL",nil,GetChannelName(channel))
				else
  					SendChatMessage(LMFrame_Quote_QuoteEdit:GetText(),channel)
				end
    			UIDropDownMenu_ClearAll(LMFrame_Quote_SendQuote)
    			UIDropDownMenu_SetSelectedID(LMFrame_Quote_SendQuote,1)
			end
  			return
  end

  if (this:GetID() ~= self.db.profile[list]) then
   if (list == "_QuoteSet") then
	  if (this:GetText() ~= "Char" and this:GetText() ~= "Class") then
	    self.db.profile.ActiveSet = this:GetText()
	  end
	end
  	self.db.profile[list] = this:GetID()
	self:GUI_Input_Disable()
   LMFrame_Quote_QuoteEdit:ClearFocus()
	self:Auto_Vars()
  	self:GUI_ListBox_OnShow("LMFrame_Quote"..list)

  else
    self.db.profile[list] = this:GetID()
  end
  self:Update_GUI_Data()
end

function Loudmouth:GUI_DropDown_OnShow()
  --local listname = string.sub(this:GetName(),14)
  local listname = string.sub(this:GetName(),(strlen("LMFrame_Quote")+1))

  if (listname == "_QuoteSet") then
    UIDropDownMenu_SetSelectedName(this,self.current_set_name)
    UIDropDownMenu_SetWidth(80,LMFrame_Quote_QuoteSet)
  end
  if (listname == "_QuoteEvent") then
  	 UIDropDownMenu_SetSelectedName(this,self.current_event_name)
    UIDropDownMenu_SetWidth(80,LMFrame_Quote_QuoteEvent)
	 --LMFrame_Quote_QuoteEvent:ClearAllPoints()
	 --LMFrame_Quote_QuoteEvent:SetPoint("LEFT",LMFrame_Quote_QuoteSet,"RIGHT", 5, 0)
  end
  if (listname == "_SendQuote") then
	 self:GUI_DropDown_Initialize(this)
    UIDropDownMenu_SetSelectedID(LMFrame_Quote_SendQuote,1)
  end
end

function Loudmouth:GUI_Get_Tab_Index(string)
  for i = 1, #self.Tabs do
    if (self.Tabs[i]["text"] == string) then 
	   return i
	 end
  end
  return false
end

function Loudmouth:GUI_Input_Disable(keepfocus)
  if not keepfocus then
    keepfocus = 0
    --LMFrame_Quote_QuoteEdit:ClearFocus()
  --else
    --LMFrame_Quote_QuoteEdit:SetFocus()
  end

  --self:Print("InputDisable(Keepfocus) = "..keepfocus)
  --if (keepfocus ~= 1) then
    --LMFrame_Quote_QuoteEdit:ClearFocus()
  --end
  LMFrame_Quote_QuoteEdit:SetText("")
  LMFrame_Quote_QuoteList_Highlight:Hide()
  self.editing_item = 0
  LMFrame_Quote_NumCharsLeft:SetText("")
  LMFrame_Quote_NumCharsLeft:Hide()
  LMFrame_Quote_CharsLeft:Hide()
  LMFrame_Quote_ButtonDelete:Hide()
  LMFrame_Quote_ButtonCancel:Hide()
  LMFrame_Quote_ButtonSave:Hide()
  LMFrame_Quote_SendQuote:Hide()
  LMEditFrame_Emote:SetChecked(0)
  LMEditFrame:Hide()
end

function Loudmouth:GUI_Input_Enable()
  LMFrame_Quote_ButtonCancel:Show()
  LMFrame_Quote_ButtonSave:Show()
  LMFrame_Quote_NumCharsLeft:Show()
  LMFrame_Quote_CharsLeft:Show()
  if (self.editing_item ~= 0) then
    LMFrame_Quote_ButtonSave:SetText("Update")
	 LMFrame_Quote_ButtonCancel:SetText("Cancel Update")
    LMFrame_Quote_ButtonDelete:Show()
  else
    LMFrame_Quote_ButtonSave:SetText("Add")
	 LMFrame_Quote_ButtonCancel:SetText("Cancel Add")
  end
  LMEditFrame:Show()
  LMFrame_Quote_SendQuote:Show()
end

function Loudmouth:GUI_ListBox_OnScroll()
  self:Auto_Vars()
  local scrollbar = LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar
  local buttonNo = 1
  local n = scrollbar:GetValue() - 1

  for i = 1, 15, 1 do
    getglobal("LMFrame_Quote_QuoteList_Button"..i.."_Text"):SetText("");
  end

  local temp = self.editing_item - n
  if temp <= 0 or temp >= 16 then
    LMFrame_Quote_QuoteList_Highlight:Hide();
  else
    local highlight = LMFrame_Quote_QuoteList_Highlight;
    highlight:Show();
    highlight:ClearAllPoints();
    highlight:SetPoint("TOPLEFT", "LMFrame_Quote_QuoteList_Button"..temp, "TOPLEFT", 0, 0);
  end

  --self:GUI_ListBox_OnShow()
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Disable()
  for key = 1, #quotelist do
    value = quotelist[key]["quote"]
    if n == 0 then
      if buttonNo == 16 then
        LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Enable();
		  return
      end
      getglobal("LMFrame_Quote_QuoteList_Button"..buttonNo.."_Text"):SetText(value);
      buttonNo = buttonNo + 1;
    else
      n = n - 1;
		LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Enable()
    end
  end
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Disable()
end

function Loudmouth:GUI_ListBox_OnShow(offset)
  self:Auto_Vars()
  local i = 4;
  local scrollsteps = self.current_num_quotes-14
  if (scrollsteps < 1) then scrollsteps = 1 end
  if (not offset) then
    offset = 1
  end

  LMFrame_Quote_QuoteList:EnableMouseWheel(true)
  LMFrame_Quote_QuoteList:SetScript("OnMouseWheel", function()
  	if arg1 > 0 then LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Click() 
	elseif arg1 < 0 then LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Click()
	end
  end)
  for i = 1, 15 do
    getglobal("LMFrame_Quote_QuoteList_Button"..i.."_Text"):SetText("")
    getglobal("LMFrame_Quote_QuoteList_Button"..i..""):Hide()
  end
  LMFrame_Quote_QuoteList_ScrollFrame:Hide()
  LMFrame_Quote_QuoteList_Label:SetText(L["Quote List"].." - "..self.current_num_quotes.." "..L["quotes"]);
  for i = 1, #quotelist
  do
	if (i <= 15)
	then	getglobal("LMFrame_Quote_QuoteList_Button"..i.."_Text"):SetText(quotelist[i]["quote"])
    		getglobal("LMFrame_Quote_QuoteList_Button"..i):Show()
	else	LMFrame_Quote_QuoteList_ScrollFrame:Show()
	end
  end
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetMinMaxValues(1,scrollsteps)
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetValue(1)
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollUpButton:Disable()
  if (scrollsteps > 1)
  then	LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Enable()
  else	LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar_ScrollDownButton:Disable()
  end
end

function Loudmouth:GUI_ListButton_OnClick(button)
  self:Auto_Vars()
  local listnum=tonumber(strsub(button:GetName(),strfind(button:GetName(),"n",-3)+1))
  local quotenum=listnum+LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetValue()-1
  if (quotenum <= #quotelist)
  then
    self.editing_item=quotenum
    LMFrame_Quote_QuoteEdit:SetText(getglobal(button:GetName().."_Text"):GetText())
	 LMEditFrame_Emote:SetChecked(quotelist[self.editing_item]["emote"])
    LMFrame_Quote_QuoteList_Highlight:Show()
    LMFrame_Quote_QuoteList_Highlight:ClearAllPoints()
    LMFrame_Quote_QuoteList_Highlight:SetPoint("TOPLEFT",button:GetName(), "TOPLEFT", 0, 0)
	 LMFrame_Quote_QuoteEdit:SetFocus()
	 LMFrame_Quote_QuoteEdit:HighlightText(strlen(LMFrame_Quote_QuoteEdit:GetText()))
  else
    self:Print("Not editing that quote, it's blank.");
  end
end

function Loudmouth:GUI_ListButton_HideTooltip(button)
  GameTooltip:Hide()
end

function Loudmouth:GUI_ListButton_ShowTooltip(button)
  self:Auto_Vars()
  local boxwidth, textwidth
  local thisquote
  local listnum=tonumber(strsub(button:GetName(),strfind(button:GetName(),"n",-3)+1))
  local quotenum=listnum+LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetValue()-1

  LMFrame_Quote_Temp_String_Text:SetText(getglobal(this:GetName().."_Text"):GetText())
  boxwidth = getglobal(this:GetName().."_Text"):GetStringWidth()
  textwidth = LMFrame_Quote_Temp_String_Text:GetWidth()

  if (textwidth > boxwidth or self:Quote_Has_Options(quotenum) == true)
  then
      thisquote = getglobal(this:GetName().."_Text"):GetText()
		if (quotelist[quotenum]["emote"] == 1) then
		  thisquote = "/me "..thisquote
		end
  		GameTooltip:SetOwner(button,"ANCHOR_TOPLEFT")
  		GameTooltip:AddLine("Quote:",  1.0, 1.0, 1.0, 1.0, 0)
		GameTooltip:AddLine(thisquote, 0.3, 0.8, 1.0, 1.0, 1)
		if (self:Quote_Has_Options(quotenum)) then
  		  GameTooltip:AddLine("Options:",  1.0, 1.0, 1.0, 1.0, 0)
		end
		if (quotelist[quotenum]["emote"] == 1) then
		  GameTooltip:AddLine("Emote", 0.3, 0.8, 1.0, 1.0, 1)
		end
		GameTooltip:Show()
  end
end

function Loudmouth:GUI_Quote_Edit_Updating()
  if (strlen(LMFrame_Quote_QuoteEdit:GetText()) >= 1) then	
  	if (self.editing_item == 0 and self.current_set_name == "All") then
		self:GUI_Input_Disable()
	else
  		self:GUI_Input_Enable()
  		LMFrame_Quote_NumCharsLeft:SetText((255-strlen(LMFrame_Quote_QuoteEdit:GetText())))
	end
  else	
  	self:GUI_Input_Disable()
  end
end

function Loudmouth:GUI_Rate_Edit_Changed(Box)
  if (Box == nil) then return end

  if (Box:GetName() == "LMFrame_Quote_Rate_EditBox") then
    self:Set_Rate(self.current_event_name, tonumber(Box:GetText()))
    getglobal(Box:GetParent():GetName().."_Slider"):SetValue(tonumber(Box:GetText()))
  end

  if (Box:GetName() == "LMFrame_Options_Wisecrack_EditBox") then
    self:Set_Rate("Wisecrack", tonumber(Box:GetText()))
	 getglobal(Box:GetParent():GetName().."_Slider"):SetValue(tonumber(Box:GetText()))
  end

  self:Update_GUI_Data()
end

function Loudmouth:GUI_Rate_Show()
  if (self.current_event_name == "Excuses" or
      self.current_event_name == "AFK")
  then	LMFrame_Quote_Rate:Hide()
  			LMFrame_Quote_Enable:Show()
			LMFrame_Quote_Enable:SetChecked(self:Get_Event_State())
  else	
			if (self:Get_Event_State()==1)
			then	LMFrame_Quote_Rate:Show()
			else	LMFrame_Quote_Rate:Hide()
			end
  			LMFrame_Quote_Enable:Show()
  			LMFrame_Quote_Rate_Label:SetText(self.current_event_name..L[" Rate     Slider    Value  "])
			LMFrame_Quote_Enable:SetChecked(self:Get_Event_State())
  			LMFrame_Quote_Rate_EditBox:SetText(self:Get_Rate())
  			LMFrame_Quote_Rate_SliderLow:SetText("0")
  			LMFrame_Quote_Rate_SliderHigh:SetText("100")
  			LMFrame_Quote_Rate_Slider:SetMinMaxValues(0,100)
  			LMFrame_Quote_Rate_Slider:SetValueStep(1)
  			LMFrame_Quote_Rate_Slider:SetValue(self:Get_Rate())
  end
  LMFrame_Options_Wisecrack_Slider:SetValue(self:Get_Rate("Wisecrack"))
end

function Loudmouth:GUI_Rate_Slider_Changed(Slider)
  if (Slider == nil) then return end

  if (Slider:GetName() == "LMFrame_Quote_Rate_Slider") then
    self:Set_Rate(self.current_event_name, tonumber(Slider:GetValue()))
    getglobal(Slider:GetParent():GetName().."_EditBox"):SetText(tonumber(Slider:GetValue()))
  end
  if (Slider:GetName() == "LMFrame_Options_Wisecrack_Slider") then
    self:Set_Rate("Wisecrack", tonumber(Slider:GetValue()))
    getglobal(Slider:GetParent():GetName().."_EditBox"):SetText(tonumber(Slider:GetValue()))
  end
  self:Update_GUI_Data()
end

function Loudmouth:GUI_Show()
  LMFrame:Show();
end

function Loudmouth:GUI_Show_Help()
local text = [[

Beta Testers:
Apep and Krink of "The Refugee Camp" on Blackhand

On the Quotes tab, choose the Quote Set you wish to use. Choose the Event Type.
The quotes for that selected event in the selected set are shown. Click on an
existing quote to edit it. To cancel without changes, click the cancel button.
If you wish to add a quote, simply type the new quote into the text box. The
button to the far right will identify whether you're adding a quote or editing
a quote. Quotes will automatically be 'spoken' by you in the Babble Channel, 
unless the emote button is checked. If the emote button is checked, then the 
quote will be sent as if you had typed "/me <text of quote>". To include your 
target's name in the quote, use %t in your quote. If your Babble Channel is set
to 'Raid' and you're not in a raid, it will step down checking for a party, then
saying it to those around you as appropriate. Excuses are sent the same way as
other quotes. AFK messages will only be displayed to guild and/or raid/party.

These are sets of quotes for each event type that can be grouped. Char and 
Class are two special sets that are always used. When referring to a currently
selected set for quoting, Char and Class do not apply.

Quotes are selected from the currently selected Quote Set from the Quotes tab.
When an event triggers a quote, it is taken from the current Quote Set, Char 
set, and Class Set. Quotes will be expressed if a random 1-100 is less than the
quote percentage shown on the Quote tab. This means if you crit 10% of the time
and have a crit quote rate of 10%, then about 1% of your hits will generate a
quote.
]]
  LMFrame_Help_Label:SetText("Loudmouth Help")
  if (beta == nil) then
  beta=LMFrame_Help:CreateFontString("LMFrame_Help_Beta","OVERLAY","GameFontNormal")
  beta:SetText(text)
  beta:SetJustifyH("LEFT")
  beta:SetPoint("TOP","LMFrame_Help_Label","BOTTOM")
  end
end

function Loudmouth:GUI_Tab_OnClick()
  --local tab = Loudmouth.Tabs[this:GetName()]
  local tab = LMFrame.selectedTab
  local index

  for index = 1, #self.Tabs do
    if (self.Tabs[index]["index"] == tab) then
    	self.Tabs[index]["framelink"]:Show()
	 else
    	self.Tabs[index]["framelink"]:Hide()
	 end
  end
end

--
-- Loudmouth Logic code
--

function Loudmouth:Auto_Vars()
  self.current_event_id=self.db.profile["_QuoteEvent"]
  self.current_event_name=self.dropdowns.Lists["_QuoteEvent"].table[self.db.profile["_QuoteEvent"]]
  self.current_set_name=self.dropdowns.Lists["_QuoteSet"].table[self.db.profile["_QuoteSet"]]
  self:Get_Quote_Event(self.current_event_name,self.current_set_name)
  self.current_num_quotes=#quotelist
  --self.current_total_quotes = self:Num_Quotes()
end

function Loudmouth:BeatTheOdds(rate)
  local randomvalue = math.random()

  --self:Debug("Random: "..randomvalue.." rate: "..rate)
  if (randomvalue <= (rate/100)) then
    return true
  else
    return false
  end
end

function Loudmouth:Choose_Quote_Event(event, set)
  local index, item

  if not set then
    set = self.db.profile.ActiveSet
  end
  self:Get_Quote_Event(event,set)
  if (#quotelist >= 1) then
    index = math.random(#quotelist)
    while (#quotelist > 1 and self.lastQuoteID[event] == index) do
      index = math.random(#quotelist)
    end
    for item in pairs(quotelist[index]) do
      currentquote[item] = quotelist[index][item]
    end
    self.lastQuoteID[event] = index
  end
end

function Loudmouth:Get_Event_State(event)
  if not event then
    event = self.current_event_name
  end

  if self.db.profile.enabled[event] == true then
    self.db.profile.enabled[event] = 1
  end
  if self.db.profile.enabled[event] == false then
    self.db.profile.enabled[event] = 0
  end

  return self.db.profile.enabled[event]
end

function Loudmouth:Get_Quote_Event(event,set)
  local all, index, item, offset, table
  local allquotes = self.db.profile.quotes
  local myquotes = self.db.char.quotes
  
  all = false
  offset = 0
  self:Reset_Quote_Vars()

  if (not set or set == "All") then
    set = self.current_set_name
    all = true
  end

  if (set ~= "Class" and set ~= "Char") then
    if (all) then
	 	for set,tables in pairs(allquotes) do
			if (set ~= "Class") then
    			for index = 1, #self.db.profile.quotes[set][event]
	 			do
					quotelist[index] = {}
      			quotelist[index]["quote"] = allquotes[set][event][index]["quote"]
	   			quotelist[index]["emote"] = allquotes[set][event][index]["emote"]
      			offset = index
	 			end
			end
		end
	else
    	for index = 1, #self.db.profile.quotes[set][event]
	 	do
			quotelist[index] = {}
      	quotelist[index]["quote"] = allquotes[set][event][index]["quote"]
	   	quotelist[index]["emote"] = allquotes[set][event][index]["emote"]
      	offset = index
	 	end
	 end
  end
  if (all or set == "Class") then
    for index = 1, #self.db.profile.quotes["Class"][self.class][event]
	 do
		offset = offset + 1
		quotelist[offset] = {}
	   quotelist[offset]["quote"] = allquotes["Class"][self.class][event][index]["quote"]
		quotelist[offset]["emote"] = allquotes["Class"][self.class][event][index]["emote"]
	 end
  end
  if (all or set == "Char") then
    for index = 1, #self.db.char.quotes[event]
	 do
		offset = offset + 1
		quotelist[offset] = {}
	   quotelist[offset]["quote"] = myquotes[event][index]["quote"]
		quotelist[offset]["emote"] = myquotes[event][index]["emote"]
	 end
  end
  --if (self.db.profile.Debug) then
    --for index = 1, #quotelist
    --do
  	   --self:Debug("#"..index.." '"..quotelist[index]["quote"].."' Emote: "..quotelist[index]["emote"])
    --end
  --end
end

function Loudmouth:Get_Rate(event)
  if not event and self.current_event_name then
  event = self.current_event_name
  end

  if event and self.db.profile.rates[event] then
    return self.db.profile.rates[event]
  else
    return nil
  end
end

function Loudmouth:Num_Quotes()
  local number = 0
  local setidx = ""
  local eventidx = ""
  local classidx = ""

  setidx = next(self.db.profile.quotes, nil)
  while (setidx ~= nil)
  do
    if (setidx ~= "Class") then
  	 	eventidx = next(self.db.profile.quotes[setidx], nil)
	 	while (eventidx ~= nil)
	 	do
	   	self:Debug("Number of quotes in "..setidx.."-"..eventidx.." "..#self.db.profile.quotes[setidx][eventidx])
			number = number + #self.db.profile.quotes[setidx][eventidx]
	 		eventidx = next(self.db.profile.quotes[setidx], eventidx)
	 	end
	 end
	 setidx = next(self.db.profile.quotes, setidx)
  end
  setidx = next(self.db.profile.quotes["Class"], nil)
  while (setidx ~= nil)
  do
  	 eventidx = next(self.db.profile.quotes["Class"][setidx], nil)
	 while (eventidx ~= nil)
	 do
	  	self:Debug("Number of quotes in Class "..setidx.."-"..eventidx.." "..#self.db.profile.quotes["Class"][setidx][eventidx])
		number = number + #self.db.profile.quotes["Class"][setidx][eventidx]
	 	eventidx = next(self.db.profile.quotes["Class"][setidx], eventidx)
	 end
	 setidx = next(self.db.profile.quotes["Class"], setidx)
  end
  eventidx = next(self.db.char.quotes, nil)
  while (eventidx ~= nil)
  do
	 self:Debug("Number of quotes in "..eventidx.." "..#self.db.char.quotes[eventidx])
	 number = number + #self.db.char.quotes[eventidx]
	 eventidx = next(self.db.char.quotes, eventidx)
  end
  return number
end

function Loudmouth:Output_AFK()
  self:UnregisterEvent("CHAT_MSG_SYSTEM")
  if (self:Get_Event_State("AFK") == 1) then
    self:Choose_Quote_Event("AFK")
    SendChatMessage(currentquote["quote"],"Guild")
    if (GetNumRaidMembers() > 1) then
      SendChatMessage(currentquote["quote"],"Raid")
    elseif (GetNumPartyMembers() >= 1) then
      SendChatMessage(currentquote["quote"],"Party")
    end
    SendChatMessage(currentquote["quote"],"AFK")
  end
  self:RegisterEvent("CHAT_MSG_SYSTEM")
end

function Loudmouth:Output_Excuse(x)
  --if x then
  	--self:Print("Output_Excuse("..x..")")
  --end
  if (self:Get_Event_State("Excuses") == 1) then
    self:Choose_Quote_Event("Excuses")
    self:Spew(x)
  end
end

function Loudmouth:Quote_Delete()
  local idx = self.editing_item
  local i

  if (self.current_set_name == "Char") then
    table.remove(self.db.char.quotes[self.current_event_name],self.editing_item)
  elseif (self.current_set_name == "Class") then
    table.remove(self.db.profile.quotes["Class"][self.class][self.current_event_name],self.editing_item)
  else
    table.remove(self.db.profile.quotes[self.current_set_name][self.current_event_name],self.editing_item)
  end
  self:GUI_Input_Disable()
   LMFrame_Quote_QuoteEdit:ClearFocus()
  self:Auto_Vars()
  self:Update_GUI_Data()
  self.current_total_quotes = self.current_total_quotes - 1
  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
end

function Loudmouth:Quote_Add(quote, set, event)
  local newindex
  if (set == "Char") then
    newindex = #self.db.char.quotes[event] + 1
    self.db.char.quotes[event][newindex] = {}
	 self.db.char.quotes[event][newindex]["quote"] = quote
	 self.db.char.quotes[event][newindex]["emote"] = LMEditFrame_Emote:GetChecked()
  elseif (set == "Class") then
    newindex = #self.db.profile.quotes["Class"][self.class][event] + 1
    self.db.profile.quotes["Class"][self.class][event][newindex] = {}
	 self.db.profile.quotes["Class"][self.class][event][newindex]["quote"] = quote
	 self.db.profile.quotes["Class"][self.class][event][newindex]["emote"] = LMEditFrame_Emote:GetChecked()
  else
    newindex = #self.db.profile.quotes[set][event] + 1
    self.db.profile.quotes[set][event][newindex] = {}
	 self.db.profile.quotes[set][event][newindex]["quote"] = quote
	 self.db.profile.quotes[set][event][newindex]["emote"] = LMEditFrame_Emote:GetChecked()
  end
  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
  self:Auto_Vars()
  self:GUI_Input_Disable(1)
  local _,max=LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetMinMaxValues()
  LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetValue(max)
  self.current_total_quotes = self.current_total_quotes + 1
  self:GUI_ListBox_OnScroll()
end

function Loudmouth:Quote_Edit()
  self:Auto_Vars()
  local quote = LMFrame_Quote_QuoteEdit:GetText()
  --local event = self.db.profile["_QuoteEvent"]
  --local event_name = self.dropdowns.Lists["_QuoteEvent"].table[event]
  --local next_index = #self.db.profile.quotes[self.current_set_name][self.current_event_name]+1
  local last_seen = 0

  if (strlen(quote) == 0) then	
    --self:Print(L["Quote was blank. Skipping."])
  	 return
  end
  last_seen = self.editing_item
  if (self.editing_item == 0) then
    self:Quote_Add(quote,self.current_set_name,self.current_event_name)
	 return
  --end
  --if (self.editing_item > 0) then
  else
    self:Quote_Replace(quote,self.current_set_name,self.current_event_name)
	 return
  end

  if (self.editing_item > 0 and strlen(quote) > 0) then	
	if (not self.db.profile.quotes[self.current_set_name][self.current_event_name][self.editing_item]) then
		self.db.profile.quotes[self.current_set_name][self.current_event_name][self.editing_item] = {}
	end
  	self.db.profile.quotes[self.current_set_name][self.current_event_name][self.editing_item]["quote"] = quote
	self.db.profile.quotes[self.current_set_name][self.current_event_name][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
	self.editing_item = 0
  end

  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
  self:GUI_Input_Disable()
   LMFrame_Quote_QuoteEdit:ClearFocus()
  self:Auto_Vars()
  if (scrolltobottom)
  then	local _,max=LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:GetMinMaxValues()
  			LMFrame_Quote_QuoteList_ScrollFrame_ScrollBar:SetValue(max)
  			self:GUI_ListBox_OnScroll()
  end
end

function Loudmouth:Quote_Has_Options(number)
  local result = false

  if (quotelist[number]["emote"] == 1) then
    result = true
  end
  return result
end

function Loudmouth:Quote_Replace(quote, set, event)
  if (set == "Char") then
	 self.db.char.quotes[event][self.editing_item]["quote"] = quote
	 self.db.char.quotes[event][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
  elseif (set == "Class") then
	 self.db.profile.quotes["Class"][set][event][self.editing_item]["quote"] = quote
	 self.db.profile.quotes["Class"][set][event][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
  else
	 self.db.profile.quotes[set][event][self.editing_item]["quote"] = quote
	 self.db.profile.quotes[set][event][self.editing_item]["emote"] = LMEditFrame_Emote:GetChecked()
  end
  self:GUI_ListBox_OnShow("LMFrame_Quote_QuoteList")
  self:Auto_Vars()
  self:GUI_Input_Disable(1)
  LMFrame_Quote_QuoteEdit:ClearFocus()
end

function Loudmouth:Reset_Quote_Vars()
  local item = nil

  statement = ""
  currentquote["quote"] = ""
  currentquote["emote"] = 0

  for item = 1, #quotelist
  do
    table.remove(quotelist,item)
  end
end

function Loudmouth:Set_Event_State(event,value)
  if value == nil then
    value = 0
  end
  self.db.profile.enabled[event] = value
end

function Loudmouth:Set_Rate(event, value)
  self.db.profile.rates[event] = value
end

function Loudmouth:Spew(ovr)
  if (statement == '') then
    if currentquote["quote"] == '' then 
	   return 
    else
	   statement = currentquote["quote"]
	 end
  end

  local output = self.db.profile.Channel

  if ovr then
	if (ovr == "g" or ovr == "G" or ovr=="Guild") then output = "Guild" end
	if (ovr == "o" or ovr == "O" or ovr=="Officer") then output = "Officer" end
	if (ovr == "p" or ovr == "P" or ovr=="Party") then output = "Party" end
	if (ovr == "r" or ovr == "R" or ovr=="Raid") then output = "Raid" end
	if (ovr == "s" or ovr == "S" or ovr=="Say") then output = "Say" end
	if (ovr == "u" or ovr == "U" or ovr=="UI") then output = "UI" end
	if (ovr == "y" or ovr == "Y" or ovr=="Yell") then output = "Yell" end
  end
  
  local orig_output = output

  self.LastQuoted = GetTime()
  if (GetNumRaidMembers() == 0 and output == 'Raid') then output = 'Party'; end 
  if (GetNumPartyMembers() == 0 and output == 'Party') then output = 'Say'; end

  if (orig_output ~= output) 
  then self:Debug("Downgrading from "..orig_output.." to "..output)
  end

  if (currentquote["emote"] == 1) then output = "EMOTE" end

  if (output == "UI") then
    self:Print(statement)
  elseif (type(output) == "number") then
    self:Print("Got a number!")
  else
    SendChatMessage(statement,output)
  end

  --
  -- The following line probably doesn't belong here, I just wanted to save 
  -- this default in a function I'm sure will be called eventually
  --
  if (self:IsDebugging() == true) then
    self.db.profile.Debug = 1
  else
    self.db.profile.Debug = 0
  end
end

function Loudmouth:Throttle()
  if (self.db.profile.Debug) then
    return false
  end

  if (GetTime() - self.LastQuoted < self.db.profile.rates["Wisecrack"]) then	
    self:Debug("Throttling output, said something too recently.")
  	 return true
  end
  return false
end

function Loudmouth:Update_GUI_Data()
  LMFrame_Options_Debug:SetChecked(self.db.profile.Debug)
  self:GUI_Rate_Show()
  self:Update()
end

function Loudmouth:Vasectomy()
  local set,event,index,class,comment,value

	if (UnitSex("Player") == 2) then
		comment = L["Vasectomy."]
	elseif (UnitSex("Player") == 3) then
		comment = L["Mastectomy."]
	elseif (UnitSex("Player") == 1) then
		comment = L["Sterilization of... whatever you are."]
	end -- gender check
  for set,value in pairs(self.db.profile.quotes) do
  		if (set == "Class") then
			for class = 1,#self.db.profile.quotes["Class"] do
				for event = 1,#self.db.profile.quotes["Class"][class] do
					for index = 1,#self.db.profile.quotes["Class"][class][event] do
						if (strlen(self.db.profile.quotes["Class"][class][event][index]["quote"]) < 1) then
							self:Print(L["Biopsy shows that quote # "]..index..L[" in Class set for "]..set..L[" for event "]..event..L[" is zero length. Initiating "]..comment)
							table.remove(self.db.profile.quotes["Class"][class][event],index)
							index = index - 1
						end -- strlen
					end -- index
				end -- event
			end -- class
		else
			for event,value in pairs(self.db.profile.quotes[set]) do
				for index = 1,#self.db.profile.quotes[set][event] do
					if (strlen(self.db.profile.quotes[set][event][index]["quote"]) < 1) then
						self:Print(L["Biopsy shows that quote # "]..index..L[" in set "]..set..L[" for event "]..event..L[" is zero length. Initiating "]..comment)
						table.remove(self.db.profile.quotes[set][event],index)
						index = index - 1
					end
				end
			end
		end
  end
	for event,value in pairs(self.db.char.quotes) do
		for index = 1,#self.db.char.quotes[event] do
			if (strlen(self.db.char.quotes[event][index]["quote"]) < 1) then
				self:Print(L["Biopsy shows that quote # "]..index..L[" in set Char for event "]..event..L[" is zero length. Initiating "]..comment)
				table.remove(self.db.char.quotes[event],index)
				index = index - 1
			end
		end
	end
end

--
-- All Event handlers are located below this comment
--

function Loudmouth:RegisterMyEvents()
  self:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS") -- arg1=msg
  self:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES") -- arg1=msg
  self:RegisterEvent("CHAT_MSG_EMOTE") -- arg1=msg arg2=player
  self:RegisterEvent("CHAT_MSG_MONSTER_EMOTE") -- arg1=msg
  self:RegisterEvent("CHAT_MSG_SYSTEM")
  self:RegisterEvent("CHAT_MSG_TEXT_EMOTE") -- arg1=msg arg2=player
  --self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE") -- arg1
  --self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE") -- arg1
  --self:RegisterEvent("CHAT_MSG_SKILL") -- arg1=msg
  --self:RegisterEvent("PLAYER_LEVEL_UP") -- arg1=level arg2-9=vals
  --self:RegisterEvent("PLAYER_PVP_KILLS_CHANGED")
  --self:RegisterEvent("PLAYER_TARGET_CHANGED")
    --local name,realm = UnitName("target")
  --self:RegisterEvent("SPELLCAST_CHANNEL_START") -- arg1=ms arg2=spell
  --self:RegisterEvent("SPELLCAST_CHANNEL_STOP")
  --self:RegisterEvent("SPELLCAST_START") --arg1=spell arg2=ms
  --self:RegisterEvent("SPELLCAST_STOP")
end

function Loudmouth:CHAT_MSG_COMBAT_SELF_HITS()
  if (self:Throttle()) then return; end
  local you1, you2 = string.find(arg1, L["You"]);
  local crit, crit2 = string.find(arg1, L["crit"]);

  self:Reset_Quote_Vars()
  if (self.db.profile.enabled["Crits"] ~= 0) then
    if (you1 == 1 and you2 == 3 and crit) then
      if (self:BeatTheOdds(self.db.profile.rates["Crits"])) then
		  self:Choose_Quote_Event("Crits")
      end
    end
  end
  self:Spew()
end

function Loudmouth:CHAT_MSG_COMBAT_SELF_MISSES()
  if (self:Throttle()) then return; end
  local message = "Loudmouth: miss"
  local item

  self:Reset_Quote_Vars()

  if (self.db.profile.enabled["Misses"] ~= 0) then
    if (self:BeatTheOdds(Loudmouth.db.profile.rates["Misses"])) then
	   self:Choose_Quote_Event("Misses")
    end
  end
  self:Spew()
end

function Loudmouth:CHAT_MSG_EMOTE()
  --self:Debug("CHAT_MSG_EMOTE: "..arg1.." "..arg2);
end

function Loudmouth:CHAT_MSG_MONSTER_EMOTE()
  if (self:Throttle()) then return; end
  local message = "Loudmouth: runaway "..arg2
  local you1, you2 = string.find(arg1, L["run"]);
  local fear, fear2 = string.find(arg1, L["fear"]);

  self:Reset_Quote_Vars()
  if (you1 ~= nil and fear ~= nil and self.db.profile.enabled["Fears"] ~= 0) then
    if (self:BeatTheOdds(self.db.profile.rates["Fears"])) then
	   self:Choose_Quote_Event("Misses")
    end
  end
  self:Spew()
end

function Loudmouth:CHAT_MSG_SYSTEM()
  if not string.find(arg1,L["You are now AFK"]) then return end
  self:Debug(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9)
  Loudmouth:Output_AFK()
end

function Loudmouth:CHAT_MSG_TEXT_EMOTE()
  self:Debug("CHAT_MSG_TEXT_EMOTE: "..arg1.." "..arg2);
end

--
-- Code Snippets and Comments I want to remember are here to the end. 
-- Probably nothing of real interest down here. :)
--

  --UIErrorsFrame:AddMessage(message,1.0,1.0,1.0,5.0)
  --self:Debug(message)
--LMF = CreateFrame("Frame",nil,UIParent)
--LMFt=LMF:CreateTexture(nil,"BACKGROUND")
--LMFt:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background")
--LMFt:SetAllPoints(LMF)
--LMF.texture=LMFt
--shown = false

  --LMF:SetFrameStrata("BACKGROUND")
  --LMF:SetWidth(100)
  --LMF:SetHeight(100)
  --LMF:SetPoint("CENTER",0,0)
  --LMF:SetMovable(true)
  --if (shown == true) then
    --LMF:Hide()
    --shown = false
  --else
    --LMF:Show()
    --shown = true
  --end

-- UnitSex("Unit") -> 1 = unknown, 2 = male, 3 = female
--function SU_EditBox:SetText(whatCommand)
  --local editBox = SU_EditBox;
  -- send the slash command to the chat box
  --ChatEdit_SendText(editBox);
--end
-- vim: ts=3 ai nu
